Bug 443513 - SNI support for mod_ssl
SNI support for mod_ssl
Product: Fedora
Classification: Fedora
Component: httpd (Show other bugs)
All Linux
low Severity low
: ---
: ---
Assigned To: Joe Orton
Fedora Extras Quality Assurance
: FutureFeature
Depends On:
  Show dependency treegraph
Reported: 2008-04-21 18:11 EDT by Ken Dreyer
Modified: 2009-08-31 19:39 EDT (History)
7 users (show)

See Also:
Fixed In Version: 2.2.13-1.fc11
Doc Type: Enhancement
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2009-08-31 19:39:25 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)

External Trackers
Tracker ID Priority Status Summary Last Updated
Apache Bugzilla 34607 None None None Never

  None (edit)
Description Ken Dreyer 2008-04-21 18:11:33 EDT
This is an enhancement request.

I am hoping the Fedora Apache maintainers will consider including the following
patch for SNI into httpd for F10:


specifically, the patch for httpd 2.2.x is:


This feature would really open up mod_ssl for certain name-based virtualhost
situations. It requires OpenSSL >= 0.9.8f, but F9 already has 0.9.8g. It also
requires OpenSSL to be compiled with TLSEXT, but the F9 package already does this.

As Matt on the fedora-devel list pointed out, the feature has already been
accepted into the trunk upstream for 2.3:

Debian has already accepted this for "lenny":

Apparently Ubuntu is still deciding:
Comment 1 Joe Orton 2008-04-22 05:10:39 EDT
I'm not patching this in, it has not passed review for the 2.2.x branch.  (I am
unconvinced it is correct as-is and need to spend some time doing some testing) 

If and when it goes into 2.2.x it'll get into Fedora via updates.
Comment 2 Joe Orton 2008-04-22 11:57:58 EDT
I confirmed my suspicion that this is not yet ready for production, FWIW.

Comment 3 Ken Dreyer 2008-04-22 18:28:55 EDT
Thanks for looking into this Joe... I can see from your email to httpd-dev that
the feature is going to need more scrutiny.
Comment 4 Bug Zapper 2008-05-14 05:53:55 EDT
Changing version to '9' as part of upcoming Fedora 9 GA.
More information and reason for this action is here:
Comment 5 Iang 2008-12-09 09:15:28 EST
The problem here is that the Priority is set to LOW and the Severity is set to LOW.  These are wrong.  Priority should be HIGHEST, Severity should be HIGHEST.

Severity first:  The number one most common of all security failures is to not use the security system.  Because of the bug in SSL (the certificate is assumed by the server) this means SSL can only be used for one certificate in production use on one IP#.  There are workarounds, but they are no good.  Then, this blockage means that the vast majority of websites use *no SSL* because it is too much trouble, and the knowledge does not share across all the other websites like vhosts do.

So SSL is not widely used;  it is an exception.  That means most of the LAMPs packages are unprotected, routinely.  The knowledge is not interesting, and the UI developers can't see the need.  The sum total of this is much broader than anything SSL has ever seen.  Lack of TLS/SNI is the most severe bug ever, by its ability to block most SSL usage.

Next, priority:  This could have been low, but in 2003 or thereabouts, phishing became a serious threat.  Phishing is a breach of the authentication in SSL and the browser UI.  Because there was so little SSL use, and because the browser vendors had basically turned off the UI security features over time, it was an easy breach.  Phishing losses are in the order of billions per year, concentrated in English speaking countries.

Anything that helps anti-phishing should be high priority.  More SSL helps because it raises the profile of authentication and makes it available to the million or so LAMPs developers.  Those developers will then work with it and get the rest of the infrastucture from "exceptional-SSL" to "routine-SSL".  UI developers will help anything that looks popular.  Plus many other things.  The task is to create a virtuous circle of attention, so that SSL can be used to deal with phishing.
Comment 6 Daniel Riek 2008-12-09 10:06:58 EST
I agree that this sounds like a good feature, although I am not in a position to judge how well it works or if there is any problematic side effect (I assume that it is safe enough to not allow easy use of stolen server certs on different sites).

Now I am not sure about the severity: isn't this just an alternative to using the cert extensions that allow multiple hostnames per cert? 

IMHO the main issue with SSL is, that most people don't care to get an official (as in CA cert shipped with the browser) CA signed cert and instead go with self-signed certs to start with. That educates customers to accept whatever cert you get from a server.

How does this help?

Responsible server admins will get a cert that covers all their server names anyways, wouldn't they?

What am I missing?
Comment 7 Iang 2008-12-09 11:19:41 EST
I don't think there is a stability problem for major sites that rely on SSL because they simply won't turn it on in the config file.  This is more for the small sites with one sysadm, a linux box, and 20 hosted sites for small businesses and friends and employer.  Grassroots.  These guys will turn it on and really don't care, as long as it works.

Alternatives include using cert extensions to include multiple hostnames per cert.  These don't scale well though because every time something changes, we have to change the entire cert, which isn't so practical.  It also means that each website owner has to "cooperate" as they are sharing a cert as if they are the same business.  (I use these in absence of TLS/SNI.)

Certainly people getting their certificate for each of their sites remains an issue, and is the other big but orthogonal thing that is holding back SSL.  CAs and browsers are working to make that easier.  I won't mention names because I have conflicts of interest there.  People not using a CA-signed cert is a completely separate issue, and controversial.  CAs have an incentive to make their product easier to use, etc.
Comment 8 Joe Orton 2008-12-10 10:49:29 EST
Ian, this lobbying is off-topic for Fedora bugzilla and does little to improve the development process.  Every user thinks that their bug/RFE of choice should be highest priority and severity.

SNI will be supported by mod_ssl in the Fedora httpd package as and when it's supported upstream.  SNI will be supported upstream as and when 2.4 is released and/or the patch is reviewed and accepted for backport to 2.2.   The SNI patches require very careful review due to the interaction with mod_ssl's access control hooks, as the existing review I performed on this patch has shown.

Please, just be patient.
Comment 9 Iang 2008-12-11 12:46:30 EST
Joe, thanks for your reply;  I agree with the practical aspects, but not with the higher conclusions.

Point 1:  Sure, it is lobbying.  What other method is available?  bugzilla is a maintenance channel, it is only a channel for bugs & patches.  When only that "language" is accepted, there is no way to even see the vast wealth of information that is available from other perspectives, such as the 5 year debate on phishing causes and fixes.  SNI fixes a bug, the precise form of which is breaching Kherckhoffs' 6th principle (usability).  But "by agreement" it is kicked up to the architectural level, and claimed to be a feature enhancement, by all developers.  By this flip of perspective, hands are washed, "enhancements" are unimportant.

Once it has been so poorly classified, there is no other choice but to lobby.
Comment 10 Iang 2008-12-11 12:52:12 EST
> Every user thinks that their bug/RFE of choice should be highest priority and severity.

Well, sure.  Point 2:  Let's see if we can agree on something.  Do you believe that SSL in httpd is used firstly for authentication of websites?  (IOW the second purpose of transport encryption is less interesting if the authentication is breached.)

And, do you agree that phishing is because of a failure of authentication of websites?  (Not necessarily in SSL, but nearby to SSL, at the application level...)

So, if that is agreeable, we can probably also agree that _ease of use of SSL_ has an inverse correlation to phishing, because if SSL was used "properly" we wouldn't have this problem.  Ease of use goes up, phishing down?  (To restate Kerckhoffs' 6th.)

Even if the correlation is only 1%, that's enough to make this the most expensive problem ever seen in the lifetime of SSL.
Comment 11 Iang 2008-12-11 13:02:13 EST
> please, just be patient.

Point 3, last:  The victims of phishing are being told they are LOW priority and LOW severity.  What else matters, ahead of actual breaches?

Last point!
Comment 12 Joe Orton 2009-01-22 09:55:03 EST
(In reply to comment #9)
> Point 1:  Sure, it is lobbying.  What other method is available? 

Contributing to the development community by doing patch review, testing, etc, rather than simply talking about how other people should spend their time.
Comment 13 Bug Zapper 2009-06-09 20:20:48 EDT
This message is a reminder that Fedora 9 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 9.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '9'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 9's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 9 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
Comment 14 Robert Scheck 2009-06-10 02:34:40 EDT
This bug report is still valid from my point of view - even it can't be fixed
and solved right now. Moving it forward to Rawhide and setting FutureFeature.
Comment 15 Ken Dreyer 2009-06-16 10:58:30 EDT
I believe this is slated for 2.2.12:

Comment 16 Anders Kaseorg 2009-07-28 10:49:18 EDT
httpd 2.2.12 is now released, including SNI support.
Comment 18 Fedora Update System 2009-08-25 00:32:25 EDT
httpd-2.2.13-1.fc11 has been pushed to the Fedora 11 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update httpd'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/F11/FEDORA-2009-8812
Comment 19 Fedora Update System 2009-08-31 19:38:55 EDT
httpd-2.2.13-1.fc11 has been pushed to the Fedora 11 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.